diff --git a/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/Editors.jsx b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/Editors.jsx
new file mode 100644
index 000000000..b48152b11
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/Editors.jsx
@@ -0,0 +1,345 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { makeStyles, Box, Portal } from '@material-ui/core';
+import React, {useContext} from 'react';
+import { DefaultButton, PrimaryButton } from '../../../../../../static/js/components/Buttons';
+import CheckRoundedIcon from '@material-ui/icons/CheckRounded';
+import CloseIcon from '@material-ui/icons/Close';
+import gettext from 'sources/gettext';
+import clsx from 'clsx';
+import JSONBigNumber from 'json-bignumber';
+import JsonEditor from '../../../../../../static/js/components/JsonEditor';
+import PropTypes from 'prop-types';
+import { RowInfoContext } from '.';
+import Notifier from '../../../../../../static/js/helpers/Notifier';
+
+const useStyles = makeStyles((theme)=>({
+  textEditor: {
+    position: 'absolute',
+
+    zIndex: 1050,
+    backgroundColor: theme.palette.background.default,
+    padding: '0.25rem',
+    fontSize: '12px',
+    ...theme.mixins.panelBorder.all,
+    left: 0,
+    // bottom: 0,
+    top: 0,
+    '& textarea': {
+      width: '250px',
+      height: '80px',
+      border: 0,
+      outline: 0,
+      resize: 'both',
+    }
+  },
+  jsonEditor: {
+    position: 'absolute',
+    zIndex: 1050,
+    backgroundColor: theme.palette.background.default,
+    ...theme.mixins.panelBorder,
+    padding: '0.25rem',
+    '& .jsoneditor-div': {
+      fontSize: '12px',
+      minWidth: '525px',
+      minHeight: '300px',
+      ...theme.mixins.panelBorder.all,
+      outline: 0,
+      resize: 'both',
+      overflow: 'auto',
+    },
+    '& .jsoneditor': {
+      height: 'abc',
+      border: 'none',
+      '& .ace-jsoneditor .ace_marker-layer .ace_active-line': {
+        background: theme.palette.primary.light
+      }
+    }
+  },
+  buttonMargin: {
+    marginLeft: '0.5rem',
+  },
+  textarea: {
+    resize: 'both'
+  },
+  input: {
+    appearance: 'none',
+    width: '100%',
+    height: '100%',
+    verticalAlign: 'top',
+    outline: 'none',
+    backgroundColor: theme.palette.background.default,
+    color: theme.palette.text.primary,
+    border: 0,
+    boxShadow: 'inset 0 0 0 1.5px '+theme.palette.primary.main,
+    padding: '0 2px',
+    '::selection': {
+      background: theme.palette.primary.light,
+    }
+  },
+  check: {
+    display: 'inline-block',
+    verticalAlign: 'top',
+    width: '16px',
+    height: '16px',
+    border: '1px solid '+theme.palette.grey[800],
+    margin: '3px',
+    textAlign: 'center',
+    lineHeight: '16px',
+
+    '&.checked, &.unchecked': {
+      background: theme.palette.background.default,
+    },
+    '&.checked:after': {
+      content: '\'\\2713\'',
+      fontWeight: 'bold',
+    },
+    '&.intermediate': {
+      background: theme.palette.grey[200],
+      '&:after': {
+        content: '\'\\003F\'',
+        fontWeight: 'bold',
+      },
+    },
+  }
+}));
+
+function autoFocusAndSelect(input) {
+  input?.focus();
+  input?.select();
+}
+
+function isValidArray(val) {
+  val = val?.trim();
+  return !(val != '' && (val.charAt(0) != '{' || val.charAt(val.length - 1) != '}'));
+}
+
+function setEditorPosition(cellEle, editorEle) {
+  if(!editorEle || !cellEle) {
+    return;
+  }
+  let gridEle = cellEle.closest('.rdg');
+  let cellRect = cellEle.getBoundingClientRect();
+  let position = {
+    left: cellRect.left,
+    top: cellRect.top - editorEle.offsetHeight + 12,
+  };
+
+  if ((position.left + editorEle.offsetWidth + 10) > gridEle.offsetWidth) {
+    position.left -=  position.left + editorEle.offsetWidth - gridEle.offsetWidth + 10;
+  }
+  editorEle.style.left = position.left + 'px';
+  editorEle.style.top = position.top + 'px';
+}
+
+const EditorPropTypes = {
+  row: PropTypes.object,
+  column: PropTypes.object,
+  onRowChange: PropTypes.func,
+  onClose: PropTypes.func
+};
+
+function textColumnFinalVal(columnVal, column) {
+  if(columnVal === '') {
+    columnVal = null;
+  } else if (!column.is_array) {
+    if (columnVal === '\'\'' || columnVal === '""') {
+      columnVal = '';
+    } else if (columnVal === '\\\'\\\'') {
+      columnVal = '\'\'';
+    } else if (columnVal === '\\"\\"') {
+      columnVal = '""';
+    }
+  }
+  return columnVal;
+}
+export function TextEditor({row, column, onRowChange, onClose}) {
+  const classes = useStyles();
+  const value = row[column.key] ?? '';
+  const [localVal, setLocalVal] = React.useState(value);
+  const {getCellElement} = useContext(RowInfoContext);
+
+  const onChange = React.useCallback((e)=>{
+    setLocalVal(e.target.value);
+  }, []);
+
+  const onOK = ()=>{
+    if(column.is_array && !isValidArray(value)) {
+      console.error(gettext('Arrays must start with "{" and end with "}"'));
+    } else {
+      let columnVal = textColumnFinalVal(localVal, column);
+      onRowChange({ ...row, [column.key]: columnVal}, true);
+      onClose();
+    }
+  };
+
+  return(
+    <Portal container={document.body}>
+      <Box ref={(ele)=>{
+        setEditorPosition(getCellElement(column.idx), ele);
+      }} className={classes.textEditor}>
+        <textarea ref={autoFocusAndSelect} className={classes.textarea} value={localVal} onChange={onChange} />
+        <Box display="flex" justifyContent="flex-end">
+          <DefaultButton startIcon={<CloseIcon />} onClick={()=>onClose(false)} size="small">
+            {gettext('Cancel')}
+          </DefaultButton>
+          {column.can_edit &&
+          <>
+            <PrimaryButton startIcon={<CheckRoundedIcon />} onClick={onOK} size="small" className={classes.buttonMargin}>
+              {gettext('OK')}
+            </PrimaryButton>
+          </>}
+        </Box>
+      </Box>
+    </Portal>
+  );
+}
+TextEditor.propTypes = EditorPropTypes;
+
+export function NumberEditor({row, column, onRowChange, onClose}) {
+  const classes = useStyles();
+  const value = row[column.key] ?? '';
+  const onBlur = ()=>{
+    if(!column.is_array && isNaN(value)){
+      Notifier.error(gettext('Please enter a valid number'));
+      return;
+    } else if(column.is_array) {
+      if(!isValidArray(value)) {
+        Notifier.error(gettext('Arrays must start with "{" and end with "}"'));
+        return;
+      }
+      let checkVal = value.trim().slice(1, -1);
+      if(checkVal == '') {
+        checkVal = [];
+      } else {
+        checkVal = checkVal.split(',');
+      }
+      for (const val of checkVal) {
+        if(isNaN(val)) {
+          Notifier.error(gettext('Arrays must start with "{" and end with "}"'));
+          return;
+        }
+      }
+    }
+    onClose(column.can_edit ? true : false);
+  };
+  const onKeyDown = (e)=>{
+    if(e.code == 'Tab') {
+      e.preventDefault();
+      onBlur();
+    }
+  };
+  return (
+    <input
+      className={classes.input}
+      ref={autoFocusAndSelect}
+      value={value}
+      onChange={(e)=>{
+        if(column.can_edit) {
+          onRowChange({ ...row, [column.key]: e.target.value });
+        }
+      }}
+      // onBlur={onBlur}
+      onKeyDown={onKeyDown}
+    />
+  );
+}
+NumberEditor.propTypes = EditorPropTypes;
+
+export function CheckboxEditor({row, column, onRowChange, onClose}) {
+  const classes = useStyles();
+  const value = row[column.key] ?? null;
+  const changeValue = ()=>{
+    if(!column.can_edit) {
+      return;
+    }
+    let newVal = true;
+    if(value) {
+      newVal = false;
+    } else if(value != null && !value) {
+      newVal = null;
+    }
+    onRowChange({ ...row, [column.key]: newVal});
+  };
+  const onBlur = ()=>{onClose(true);};
+  let className = 'checked';
+  if(!value) {
+    className = 'unchecked';
+  } else if(value == null){
+    className = 'intermediate';
+  }
+  return (
+    <div onClick={changeValue} tabIndex="0" onBlur={onBlur}>
+      <span className={clsx(classes.check, className)}></span>
+    </div>
+  );
+}
+CheckboxEditor.propTypes = EditorPropTypes;
+
+export function JsonTextEditor({row, column, onRowChange, onClose}) {
+  const classes = useStyles();
+  const {getCellElement} = useContext(RowInfoContext);
+  const value = React.useMemo(()=>{
+    let newVal = row[column.key] ?? null;
+    /* If jsonb or array */
+    if(column.column_type_internal === 'jsonb' && !Array.isArray(newVal) && newVal != null) {
+      newVal = JSONBigNumber.stringify(JSONBigNumber.parse(newVal), null, 2);
+    } else if (Array.isArray(newVal)) {
+      var temp = newVal.map((ele)=>{
+        if (typeof ele === 'object') {
+          return JSONBigNumber.stringify(ele, null, 2);
+        }
+        return ele;
+      });
+      newVal = '[' + temp.join() + ']';
+    }
+    /* set editor content to empty if value is null*/
+    if (_.isNull(newVal)){
+      newVal = '';
+    }
+    return newVal;
+  });
+  const [localVal, setLocalVal] = React.useState(value);
+
+  const onChange = React.useCallback((newVal)=>{
+    setLocalVal(newVal);
+  }, []);
+  const onOK = ()=>{
+    onRowChange({ ...row, [column.key]: localVal}, true);
+    onClose();
+  };
+  return (
+    <Portal container={document.body}>
+      <Box ref={(ele)=>{
+        setEditorPosition(getCellElement(column.idx), ele);
+      }} className={classes.jsonEditor}>
+        <JsonEditor
+          value={localVal}
+          options={{
+            onChange: onChange,
+            onError: (error)=>console.error('Invalid Json: ' + error.message.split(':')[0]),
+          }}
+          className={'jsoneditor-div'}
+        />
+        <Box display="flex" justifyContent="flex-end" marginTop="0.25rem">
+          <DefaultButton startIcon={<CloseIcon />} onClick={()=>onClose(false)} size="small">
+            {gettext('Cancel')}
+          </DefaultButton>
+          {column.can_edit &&
+          <>
+            <PrimaryButton startIcon={<CheckRoundedIcon />} onClick={onOK} size="small" className={classes.buttonMargin}>
+              {gettext('OK')}
+            </PrimaryButton>
+          </>}
+        </Box>
+      </Box>
+    </Portal>
+  );
+}
+JsonTextEditor.propTypes = EditorPropTypes;
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/Formatters.jsx b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/Formatters.jsx
new file mode 100644
index 000000000..682a2e0f8
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/Formatters.jsx
@@ -0,0 +1,73 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import React from 'react';
+import _ from 'lodash';
+import { makeStyles } from '@material-ui/core';
+import PropTypes from 'prop-types';
+import CustomPropTypes from '../../../../../../static/js/custom_prop_types';
+
+const useStyles = makeStyles((theme)=>({
+  disabledCell: {
+    opacity: theme.palette.action.disabledOpacity,
+  }
+}));
+
+function NullAndDefaultFormatter({value, column, children}) {
+  const classes = useStyles();
+  if (_.isUndefined(value) && column.has_default_val) {
+    return <span className={classes.disabledCell}>[default]</span>;
+  } else if ((_.isUndefined(value) && column.not_null) ||
+      (_.isUndefined(value) || _.isNull(value))) {
+    return <span className={classes.disabledCell}>[null]</span>;
+  }
+  return children;
+}
+NullAndDefaultFormatter.propTypes = {
+  value: PropTypes.any,
+  column: PropTypes.object,
+  children: CustomPropTypes.children,
+};
+
+const FormatterPropTypes = {
+  row: PropTypes.object,
+  column: PropTypes.object,
+};
+export function TextFormatter({row, column}) {
+  let value = row[column.key];
+  if(!_.isNull(value) && !_.isUndefined(value)) {
+    value = value.toString();
+  }
+  return (
+    <NullAndDefaultFormatter value={value} column={column}>
+      <>{value}</>
+    </NullAndDefaultFormatter>
+  );
+}
+TextFormatter.propTypes = FormatterPropTypes;
+
+export function NumberFormatter({row, column}) {
+  let value = row[column.key];
+  return (
+    <NullAndDefaultFormatter value={value} column={column}>
+      <div style={{textAlign: 'right'}}>{value}</div>
+    </NullAndDefaultFormatter>
+  );
+}
+NumberFormatter.propTypes = FormatterPropTypes;
+
+export function BinaryFormatter({row, column}) {
+  let value = row[column.key];
+  const classes = useStyles();
+  return (
+    <NullAndDefaultFormatter value={value} column={column}>
+      <span className={classes.disabledCell}>[{value}]</span>
+    </NullAndDefaultFormatter>
+  );
+}
+BinaryFormatter.propTypes = FormatterPropTypes;
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/index.jsx b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/index.jsx
new file mode 100644
index 000000000..17b4b7bf9
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/QueryToolDataGrid/index.jsx
@@ -0,0 +1,398 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { Box, makeStyles } from '@material-ui/core';
+import _ from 'lodash';
+import React, {useState, useEffect, useCallback, useContext, useRef} from 'react';
+import ReactDataGrid, {Row, useRowSelection} from 'react-data-grid';
+import LockIcon from '@material-ui/icons/Lock';
+import EditIcon from '@material-ui/icons/Edit';
+import { QUERY_TOOL_EVENTS } from '../QueryToolConstants';
+import * as Editors from './Editors';
+import * as Formatters from './Formatters';
+import clsx from 'clsx';
+import { PgIconButton } from '../../../../../../static/js/components/Buttons';
+import MapIcon from '@material-ui/icons/Map';
+import { QueryToolEventsContext } from '../QueryToolComponent';
+import PropTypes, { number } from 'prop-types';
+import gettext from 'sources/gettext';
+
+export const ROWNUM_KEY = '$_pgadmin_rownum_key_$';
+export const GRID_ROW_SELECT_KEY = '$_pgadmin_gridrowselect_key_$';
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    height: '100%',
+    color: theme.palette.text.primary,
+    backgroundColor: theme.otherVars.qtDatagridBg,
+    fontSize: '12px',
+    border: 'none',
+    '--rdg-selection-color': theme.palette.primary.main,
+    '& .rdg-cell': {
+      ...theme.mixins.panelBorder.right,
+      ...theme.mixins.panelBorder.bottom,
+      fontWeight: 'abc',
+      '&[aria-colindex="1"]': {
+        padding: 0,
+      }
+    },
+    '& .rdg-header-row .rdg-cell': {
+      padding: 0,
+    },
+    '& .rdg-header-row': {
+      backgroundColor: theme.palette.background.default,
+      fontWeight: 'normal',
+    },
+    '& .rdg-row': {
+      backgroundColor: theme.palette.background.default,
+      '&[aria-selected=true]': {
+        backgroundColor: theme.palette.primary.light,
+        color: theme.otherVars.qtDatagridSelectFg,
+        '& .rdg-cell:nth-child(1)': {
+          backgroundColor: theme.palette.primary.main,
+          color: theme.palette.primary.contrastText,
+        }
+      },
+    }
+  },
+  columnHeader: {
+    padding: '3px 6px',
+    height: '100%',
+    display: 'flex',
+    lineHeight: '16px',
+    alignItems: 'center',
+  },
+  columnName: {
+    fontWeight: 'bold',
+  },
+  editedCell: {
+    fontWeight: 'bold',
+  },
+  deletedRow: {
+    '&:before': {
+      content: '" "',
+      position: 'absolute',
+      top: '50%',
+      left: 0,
+      borderTop: '1px solid ' + theme.palette.error.main,
+      width: '100%',
+    }
+  },
+  rowNumCell: {
+    padding: '0px 8px',
+  },
+  colHeaderSelected: {
+    outlineColor: theme.palette.primary.main,
+    backgroundColor: theme.palette.primary.main,
+    color: theme.palette.primary.contrastText,
+  },
+  colSelected: {
+    outlineColor: theme.palette.primary.main,
+    backgroundColor: theme.palette.primary.light,
+    color: theme.otherVars.qtDatagridSelectFg,
+  }
+}));
+
+export const RowInfoContext = React.createContext();
+
+function CustomRow(props) {
+  const rowRef = useRef();
+  const rowInfoValue = {
+    rowIdx: props.rowIdx,
+    getCellElement: (colIdx)=>{
+      return rowRef.current.querySelector(`.rdg-cell[aria-colindex="${colIdx+1}"]`);
+    }
+  };
+  return (
+    <RowInfoContext.Provider value={rowInfoValue}>
+      <Row ref={rowRef} {...props} />
+    </RowInfoContext.Provider>
+  );
+}
+
+CustomRow.propTypes = {
+  rowIdx: number,
+};
+
+function SelectAllHeaderRenderer(props) {
+  const [checked, setChecked] = useState(false);
+  const eventBus = useContext(QueryToolEventsContext);
+  const onClick = ()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.FETCH_MORE_ROWS, true, ()=>{
+      setChecked(!checked);
+      props.onAllRowsSelectionChange(!checked);
+    });
+  };
+  return <div style={{widht: '100%', height: '100%'}} onClick={onClick}></div>;
+}
+SelectAllHeaderRenderer.propTypes = {
+  onAllRowsSelectionChange: PropTypes.func,
+};
+
+function SelectableHeaderRenderer({column, selectedColumns, onSelectedColumnsChange}) {
+  const classes = useStyles();
+  const eventBus = useContext(QueryToolEventsContext);
+
+  const onClick = ()=>{
+    eventBus.fireEvent(QUERY_TOOL_EVENTS.FETCH_MORE_ROWS, true, ()=>{
+      const newSelectedCols = new Set(selectedColumns);
+      if (newSelectedCols.has(column.idx)) {
+        newSelectedCols.delete(column.idx);
+      } else {
+        newSelectedCols.add(column.idx);
+      }
+      onSelectedColumnsChange(newSelectedCols);
+    });
+  };
+
+  const isSelected = selectedColumns.has(column.idx);
+
+  return (
+    <Box className={clsx(classes.columnHeader, isSelected ? classes.colHeaderSelected : null)} onClick={onClick}>
+      {(column.column_type_internal == 'geometry' || column.column_type_internal == 'geography') &&
+      <Box>
+        <PgIconButton title={gettext('View all geometries in this column')} icon={<MapIcon />} size="small" style={{marginRight: '0.25rem'}} onClick={(e)=>{
+          e.stopPropagation();
+          eventBus.fireEvent(QUERY_TOOL_EVENTS.TRIGGER_RENDER_GEOMETRIES, column);
+        }}/>
+      </Box>}
+      <Box marginRight="auto">
+        <span className={classes.columnName}>{column.display_name}</span><br/>
+        <span>{column.display_type}</span>
+      </Box>
+      <Box marginLeft="4px">{column.can_edit ?
+        <EditIcon fontSize="small" style={{fontSize: '0.875rem'}} />:
+        <LockIcon fontSize="small" style={{fontSize: '0.875rem'}} />
+      }</Box>
+    </Box>
+  );
+}
+SelectableHeaderRenderer.propTypes = {
+  column: PropTypes.object,
+  selectedColumns: PropTypes.objectOf(Set),
+  onSelectedColumnsChange: PropTypes.func,
+};
+
+function setEditorFormatter(col) {
+  // If grid is editable then add editor else make it readonly
+  if (col.cell == 'oid' && col.name == 'oid') {
+    col.editor = null;
+    col.formatter = Formatters.TextFormatter;
+  } else if (col.cell == 'Json') {
+    col.editor = Editors.JsonTextEditor;
+    col.formatter = Formatters.TextFormatter;
+  } else if (['number', 'oid'].indexOf(col.cell) != -1 || ['xid', 'real'].indexOf(col.type) != -1) {
+    col.formatter = Formatters.NumberFormatter;
+    col.editor = Editors.NumberEditor;
+  } else if (col.cell == 'boolean') {
+    col.editor = Editors.CheckboxEditor;
+    col.formatter = Formatters.TextFormatter;
+  } else if (col.cell == 'binary') {
+    // We do not support editing binary data in SQL editor and data grid.
+    col.editor = null;
+    col.formatter = Formatters.BinaryFormatter;
+  } else {
+    col.editor = Editors.TextEditor;
+    col.formatter = Formatters.TextFormatter;
+  }
+}
+
+function cellClassGetter(col, classes, isSelected, dataChangeStore, rowKeyGetter){
+  return (row)=>{
+    let cellClasses = [];
+    if(dataChangeStore && rowKeyGetter) {
+      if(rowKeyGetter(row) in (dataChangeStore?.updated || {})
+        && !_.isUndefined(dataChangeStore?.updated[rowKeyGetter(row)]?.data[col.key])
+        || rowKeyGetter(row) in (dataChangeStore?.added || {})
+      ) {
+        cellClasses.push(classes.editedCell);
+      }
+      if(rowKeyGetter(row) in (dataChangeStore?.deleted || {})) {
+        cellClasses.push(classes.deletedRow);
+      }
+    }
+    if(isSelected) {
+      cellClasses.push(classes.colSelected);
+    }
+    return clsx(cellClasses);
+  };
+}
+
+function initialiseColumns(columns, rows, totalRowCount, columnWidthBy) {
+  let retColumns = [
+    ...columns,
+  ];
+  const canvas = document.createElement('canvas');
+  const canvasContext = canvas.getContext('2d');
+  canvasContext.font = '12px Roboto';
+
+  for(const col of retColumns) {
+    col.width = getTextWidth(col, rows, canvasContext, columnWidthBy);
+    col.resizable = true;
+    col.editorOptions = {
+      commitOnOutsideClick: false,
+      onCellKeyDown: (e)=>{
+        /* Do not open the editor */
+        e.preventDefault();
+      }
+    };
+    setEditorFormatter(col);
+  }
+
+  let rowNumCol = {
+    key: ROWNUM_KEY, name: '', frozen: true, resizable: false,
+    minWidth: 45, width: canvasContext.measureText((totalRowCount||'').toString()).width,
+  };
+  rowNumCol.cellClass = cellClassGetter(rowNumCol);
+  retColumns.unshift(rowNumCol);
+  canvas.remove();
+  return retColumns;
+}
+
+function formatColumns(columns, dataChangeStore, selectedColumns, onSelectedColumnsChange, rowKeyGetter, classes) {
+  let retColumns = [
+    ...columns,
+  ];
+
+  const HeaderRenderer = (props)=>{
+    return <SelectableHeaderRenderer {...props} selectedColumns={selectedColumns} onSelectedColumnsChange={onSelectedColumnsChange}/>;
+  };
+
+  for(const [idx, col] of retColumns.entries()) {
+    col.headerRenderer = HeaderRenderer;
+    col.cellClass = cellClassGetter(col, classes, selectedColumns.has(idx), dataChangeStore, rowKeyGetter);
+  }
+
+  let rowNumCol = retColumns[0];
+  rowNumCol.headerRenderer = SelectAllHeaderRenderer;
+  rowNumCol.formatter = ({row})=>{
+    const {rowIdx} = useContext(RowInfoContext);
+    const [isRowSelected, onRowSelectionChange] = useRowSelection();
+    let rowKey = rowKeyGetter(row);
+    let rownum = rowIdx+1;
+    if(rowKey in (dataChangeStore?.added || {})) {
+      rownum = rownum+'+';
+    } else if(rowKey in (dataChangeStore?.deleted || {})) {
+      rownum = rownum+'-';
+    }
+    return (<div className={classes.rowNumCell} onClick={()=>{
+      onSelectedColumnsChange(new Set());
+      onRowSelectionChange({ row: row, checked: !isRowSelected, isShiftClick: false});
+    }}>
+      {rownum}
+    </div>);
+  };
+
+  return retColumns;
+}
+
+function getTextWidth(column, rows, canvas, columnWidthBy) {
+  const dataWidthReducer = (longest, nextRow) => {
+    let value = nextRow[column.key];
+    if(_.isNull(value) || _.isUndefined(value)) {
+      value = '';
+    }
+    value = value.toString();
+    return longest.length > value.length ? longest : value;
+  };
+
+  let columnHeaderLen = column.display_name.length > column.display_type.length ?
+    canvas.measureText(column.display_name).width : canvas.measureText(column.display_type).width;
+  /* padding 12, icon-width 15 */
+  columnHeaderLen += 15 + 12;
+  if(column.column_type_internal == 'geometry' || column.column_type_internal == 'geography') {
+    columnHeaderLen += 40;
+  }
+  let width = columnHeaderLen;
+  if(typeof(columnWidthBy) == 'number') {
+    /* padding 16 */
+    width = 16 + Math.ceil(canvas.measureText(rows.reduce(dataWidthReducer, '')).width);
+    if(width > columnWidthBy && columnWidthBy > 0) {
+      width = columnWidthBy;
+    }
+    if(width < columnHeaderLen) {
+      width = columnHeaderLen;
+    }
+  }
+  /* Gracefull */
+  width += 2;
+  return width;
+}
+
+export default function QueryToolDataGrid({columns, rows, totalRowCount, dataChangeStore,
+  onSelectedCellChange, rowsResetKey, selectedColumns, onSelectedColumnsChange, columnWidthBy, ...props}) {
+  const classes = useStyles();
+  const [readyColumns, setColumns] = useState([]);
+  const eventBus = useContext(QueryToolEventsContext);
+  const onSelectedColumnsChangeWrapped = (arg)=>{
+    props.onSelectedRowsChange(new Set());
+    onSelectedColumnsChange(arg);
+  };
+
+  useEffect(()=>{
+    if(columns.length > 0 || rows.length > 0) {
+      let initCols = initialiseColumns(columns, rows, totalRowCount, columnWidthBy);
+      setColumns(formatColumns(initCols, dataChangeStore, selectedColumns, onSelectedColumnsChangeWrapped, props.rowKeyGetter, classes));
+    } else {
+      setColumns([], [], 0);
+    }
+  }, [columns, rowsResetKey]);
+
+  useEffect(()=>{
+    setColumns((prevCols)=>{
+      return formatColumns(prevCols, dataChangeStore, selectedColumns, onSelectedColumnsChangeWrapped, props.rowKeyGetter, classes);
+    });
+  }, [dataChangeStore, selectedColumns]);
+
+  const onRowClick = useCallback((row, column)=>{
+    if(column.key === ROWNUM_KEY) {
+      onSelectedCellChange && onSelectedCellChange(null);
+    } else {
+      onSelectedCellChange && onSelectedCellChange([row, column]);
+    }
+  }, []);
+
+  function handleCopy() {
+    if (window.isSecureContext) {
+      eventBus.fireEvent(QUERY_TOOL_EVENTS.TRIGGER_COPY_DATA);
+    }
+  }
+
+  return (
+    <ReactDataGrid
+      id="datagrid"
+      columns={readyColumns}
+      rows={rows}
+      className={classes.root}
+      headerRowHeight={40}
+      rowHeight={25}
+      mincolumnWidthBy={50}
+      enableCellSelect={true}
+      onRowClick={onRowClick}
+      onCopy={handleCopy}
+      components={{
+        rowRenderer: CustomRow,
+      }}
+      {...props}
+    />
+  );
+}
+
+QueryToolDataGrid.propTypes = {
+  columns: PropTypes.array,
+  rows: PropTypes.array,
+  totalRowCount: PropTypes.number,
+  dataChangeStore: PropTypes.object,
+  onSelectedCellChange: PropTypes.func,
+  onSelectedRowsChange: PropTypes.func,
+  selectedColumns: PropTypes.objectOf(Set),
+  onSelectedColumnsChange: PropTypes.func,
+  rowKeyGetter: PropTypes.func,
+  rowsResetKey: PropTypes.any,
+  columnWidthBy: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
+};
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmSaveContent.jsx b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmSaveContent.jsx
new file mode 100644
index 000000000..ef48b8c30
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmSaveContent.jsx
@@ -0,0 +1,39 @@
+import React from 'react';
+import { useModalStyles } from '../../../../../../static/js/helpers/ModalProvider';
+import gettext from 'sources/gettext';
+import { Box } from '@material-ui/core';
+import { DefaultButton, PrimaryButton } from '../../../../../../static/js/components/Buttons';
+import CloseIcon from '@material-ui/icons/CloseRounded';
+import CheckRoundedIcon from '@material-ui/icons/CheckRounded';
+import DeleteRoundedIcon from '@material-ui/icons/DeleteRounded';
+import HTMLReactParser from 'html-react-parser';
+import PropTypes from 'prop-types';
+
+export default function ConfirmSaveContent({closeModal, text, onDontSave, onSave}) {
+  const classes = useModalStyles();
+  return (
+    <Box display="flex" flexDirection="column" height="100%">
+      <Box flexGrow="1" p={2}>{typeof(text) == 'string' ? HTMLReactParser(text) : text}</Box>
+      <Box className={classes.footer}>
+        <DefaultButton data-test="close" startIcon={<CloseIcon />} onClick={()=>{
+          closeModal();
+        }} >{gettext('Cancel')}</DefaultButton>
+        <DefaultButton data-test="dont-save" className={classes.margin} startIcon={<DeleteRoundedIcon />} onClick={()=>{
+          onDontSave?.();
+          closeModal();
+        }} >{gettext('Don\'t save')}</DefaultButton>
+        <PrimaryButton data-test="save" className={classes.margin} startIcon={<CheckRoundedIcon />} onClick={()=>{
+          onSave?.();
+          closeModal();
+        }} autoFocus={true} >{gettext('Save')}</PrimaryButton>
+      </Box>
+    </Box>
+  );
+}
+
+ConfirmSaveContent.propTypes = {
+  closeModal: PropTypes.func,
+  text: PropTypes.string,
+  onDontSave: PropTypes.func,
+  onSave: PropTypes.func
+};
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmTransactionContent.jsx b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmTransactionContent.jsx
new file mode 100644
index 000000000..bfe88d97f
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/ConfirmTransactionContent.jsx
@@ -0,0 +1,38 @@
+import React from 'react';
+import { useModalStyles } from '../../../../../../static/js/helpers/ModalProvider';
+import gettext from 'sources/gettext';
+import { Box } from '@material-ui/core';
+import { DefaultButton, PrimaryButton } from '../../../../../../static/js/components/Buttons';
+import CloseIcon from '@material-ui/icons/CloseRounded';
+import HTMLReactParser from 'html-react-parser';
+import { CommitIcon, RollbackIcon } from '../../../../../../static/js/components/ExternalIcon';
+import PropTypes from 'prop-types';
+
+export default function ConfirmTransactionContent({closeModal, text, onRollback, onCommit}) {
+  const classes = useModalStyles();
+  return (
+    <Box display="flex" flexDirection="column" height="100%">
+      <Box flexGrow="1" p={2}>{typeof(text) == 'string' ? HTMLReactParser(text) : text}</Box>
+      <Box className={classes.footer}>
+        <DefaultButton data-test="cancel" startIcon={<CloseIcon />} onClick={()=>{
+          closeModal();
+        }} >{gettext('Cancel')}</DefaultButton>
+        <PrimaryButton data-test="rollback" className={classes.margin} startIcon={<RollbackIcon />} onClick={()=>{
+          onRollback?.();
+          closeModal();
+        }} >{gettext('Rollback')}</PrimaryButton>
+        <PrimaryButton data-test="commit" className={classes.margin} startIcon={<CommitIcon />} onClick={()=>{
+          onCommit?.();
+          closeModal();
+        }} autoFocus={true} >{gettext('Commit')}</PrimaryButton>
+      </Box>
+    </Box>
+  );
+}
+
+ConfirmTransactionContent.propTypes = {
+  closeModal: PropTypes.func,
+  text: PropTypes.string,
+  onRollback: PropTypes.func,
+  onCommit: PropTypes.func
+};
